import os
import json
import distro
import platform

def UpdateRecord(patches, secure_patches, silence_patches):
    path = '/etc/nfs/info'
    for line in open(path, 'r'):
        if "BUILDTIME=" in line:
            buildtime=line.split("=")[1].replace('\n','')
    if int(patches) < 10:
        nfs_record = "N0" + patches
    else:
        nfs_record = "N" + patches

    if int(secure_patches) < 10:
        secure_record = "S0" + secure_patches
    else:
        secure_record = "S" + secure_patches

    record_info_cmd = "sed -i s/SYSTEM_RECORD=.*/SYSTEM_RECORD=" + buildtime + nfs_record + secure_record + "/ /etc/nfs/info"
    record_release_cmd = "sed -i s/SYSTEM_RECORD=.*/SYSTEM_RECORD=" + buildtime + nfs_record + secure_record + "/ /etc/os-release"
    #print(record_info_cmd)
    #print(record_release_cmd)
    os.system(record_info_cmd)
    os.system(record_release_cmd)
    patch_ver_cmd = "sed -i s/install_patch=.*/install_patch=" + patches + "/ /etc/os-patchversion"
    secure_patch_ver_cmd = "sed -i s/install_secure_patch=.*/install_secure_patch=" + secure_patches + "/ /etc/os-patchversion"
    silence_patch_ver_cmd = "sed -i s/install_silence_patch=.*/install_silence_patch=" + silence_patches + "/ /etc/os-patchversion"
    os.system(patch_ver_cmd)
    os.system(secure_patch_ver_cmd)
    os.system(silence_patch_ver_cmd)
    #print(patch_ver_cmd)
    #print(secure_patch_ver_cmd)
    #print(silence_patch_ver_cmd)

#获取当前系统补丁信息
def getCurrentPatchInfo():
    path = '/usr/share/cdos-update/patchsymbol/patch-version.json'
    #path = './patch-version.json'
    with open(path, 'r') as fp:
        update_info=json.load(fp)
        #print(update_info)

    sys_ver = distro.os_release_info()['version']+ '-' + distro.os_release_info()['minor_version']
    #print(sys_ver)
    latest_patch_info = update_info[sys_ver][platform.machine()]
    #print(latest_patch_info)

    patches = str(latest_patch_info['patches']["patchID"])
    secure_patches = str(latest_patch_info['secure_patches']["patchID"])
    silence_patches = str(latest_patch_info['silence_patches']["patchID"])
    #print(patches)
    #print(secure_patches)
    #print(silence_patches)

    UpdateRecord(patches, secure_patches, silence_patches)


if __name__ == '__main__':

    getCurrentPatchInfo()
